%Questo agente funziona come l'agente "pulitore_1"

:- load_library('alice.tucson.api.Tucson2PLibrary').
:- solve(ingresso).
ingresso :-
	enter_context([agent_id(pulitore_2)]),
	text_from_file('specification\pulitori.pl',X),
	mappa ? set_spec(X),
	stanza ? rd(porta(A,B)),
	(mappa ? rdp(posizione_1(Z,K)),!,attendi_spostamento,
	mappa ? out(posizione_2(A,B));
	mappa ? out(posizione_2(A,B))),
	write(posizione_2(A,B)),nl,
	mappa ? out(pul_2(0)),
	Verso=0,
	movimento(Verso),
	mappa ? out(fine_2),
	write(fine_2),nl,
	exit_context.

movimento(Verso) :-
	mappa ? rd(posizione_2(X,Y)),
	(Verso==0,!,X1=X,Y1 is Y + 1;
	Verso==1,!,X1 is X + 1,Y1=Y;
	Verso==2,!,X1=X,Y1 is Y - 1;
	Verso==3,!,X1 is X - 1,Y1=Y),
	ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso),
	(Ost==0,!,
	mappa ? out(pulito_da_2(X,Y)),
	stanza ? out(pulito(X,Y)),
	mappa ? in(posizione_2(X,Y)),
	mappa ? out(posizione_2(X1,Y1)),
	write(posizione_2(X1,Y1)),nl;
	Ost==1),
	(mappa ? inp(stop_2),!;movimento(Nuovo_Verso)).

ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso) :-
	((stanza ? rdp(oggetto_fisso(X1,Y1)),!,mappa ? out(oggetto_fisso_2(X1,Y1));
	stanza ? inp(muro(X1,Y1)),!,mappa ? out(oggetto_fisso_2(X1,Y1));
	altri_pulitori(X1,Y1);
	controllo_pulito(X1,Y1,Pulito),Pulito>0,Pulito<4),!,
	gira(Verso,Nuovo_Verso),
	Ost=1;
	Ost=0,Nuovo_Verso=Verso).

altri_pulitori(X1,Y1):-
	(mappa ? rdp(posizione_1(X1,Y1)),!,mappa ? out(pulitore_1_in(X1,Y1));
	mappa ? rdp(posizione_SL1(X1,Y1)),!,mappa ? out(pulitore_SL1_in(X1,Y1));
	mappa ? rdp(posizione_TL1(X1,Y1)),!,mappa ? out(pulitore_TL1_in(X1,Y1));
	mappa ? rdp(posizione_TL2(X1,Y1)),!,mappa ? out(pulitore_TL2_in(X1,Y1));
	mappa ? rdp(posizione_TS(X1,Y1)),!,mappa ? out(trova_sporco_TS_in(X1,Y1))).

controllo_pulito(X1,Y1,Pulito):-
	mappa ? in(pul_2(Pul)),
	(stanza ? rdp(pulito(X1,Y1)),!,
	mappa ? out(zona_gia_pulita_2(X1,Y1)),
	Pulito is Pul + 1;
	Pulito=0),
	mappa ? out(pul_2(Pulito)).

gira(Verso,Nuovo_Verso) :-
	(Verso==0,!,Nuovo_Verso=3;
	Verso==3,!,Nuovo_Verso=2;
	Verso==2,!,Nuovo_Verso=1;
	Verso==1,!,Nuovo_Verso=0).

attendi_spostamento:-
	stanza ? rd(porta(X,Y)),
	mappa ? rdp(posizione_1(Z,K)),
	((X\==Z;Y\==K);attendi_spostamento).	