%controllo coordinate positive
reaction(out(dimensioni(A,B)),(
	(A<0;B<0),
	in_r(dimensioni(A,B)),
	out_r(controllare_dim(A,B)) )).

%controllo porta sul perimetro della stanza
reaction(out(porta(X,Y)),(
	rd_r(dimensioni(A,B)),
	X\==A,X\==0,Y\==B,Y\==0,
	in_r(porta(X,Y)),
	out_r(controllare_porta(X,Y,A,B)) )).

reaction(out(porta(X,Y)),(
	no_r(dimensioni(A,B)),
	in_r(porta(X,Y)) )).

%controllo pos. oggetti entro le dimensioni della stanza
reaction(out(oggetto_fisso(X,Y)),(
	rd_r(dimensioni(A,B)),
	(X>A;Y>B;X<0;Y<0),
	in_r(oggetto_fisso(X,Y)),
	out_r(controllare_oggetto(X,Y,A,B)) )).

reaction(out(oggetto_fisso(X,Y)),(
	no_r(dimensioni(A,B)),
	in_r(oggetto_fisso(X,Y)) )).

%controllo sporco entro le dimensioni della stanza
reaction(out(sporco(X,Y)),(
	rd_r(dimensioni(A,B)),
	(X>A;Y>B;X<0;Y<0),
	in_r(sporco(X,Y)),
	out_r(controllare_sporco(X,Y,A,B)) )).

reaction(out(sporco(X,Y)),(
	no_r(dimensioni(A,B)),
	in_r(sporco(X,Y)) )).

%controllo repliche di tuple identiche
reaction(out(X),(
	in_r(X),
	rd_r(X) )).

%controllo sovrapposizione "oggetti"
reaction(out(oggetto_fisso(X,Y)),(
	in_r(oggetto_fisso(X,Y)),
	(rd_r(oggetto_fisso(X,Y));
	rd_r(sporco(X,Y));
	rd_r(porta(X,Y))),
	out_r(oggetti_non_sovrapponibili) )).
reaction(out(sporco(X,Y)),(
	in_r(sporco(X,Y)),
	(rd_r(oggetto_fisso(X,Y));
	rd_r(sporco(X,Y));
	rd_r(porta(X,Y))),
	out_r(oggetti_non_sovrapponibili) )).
reaction(out(porta(X,Y)),(
	in_r(porta(X,Y)),
	(rd_r(oggetto_fisso(X,Y));
	rd_r(sporco(X,Y));
	rd_r(porta(X,Y))),
	out_r(oggetti_non_sovrapponibili) )).

%riconoscimento della presenza del muro come "oggetto fisso"
reaction(rdp(oggetto_fisso(X,Y)),(
	failure,
	X1 is X-1,
	Y1 is Y-1,
	rd_r(dimensioni(A,B)),
	(X1== A;X1== -2;Y1== B;Y1== -2),
	out_r(muro(X,Y)) )).

%controllo zona pulita => no sporca e viceversa
reaction(out(pulito(X,Y)),(
	in_r(sporco(X,Y)) )).
reaction(out(sporco(X,Y)),(
	in_r(pulito(X,Y)) )).